/* ContactImage.c generated by valac 0.40.8, the Vala compiler
 * generated from ContactImage.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2015 Maya Developers (http://launchpad.net/maya)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */
/* 
 * This widget auto-updates his image when the contact changes his avatar.
 * It draws circle icons following the current trend.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <folks/folks.h>
#include <gio/gio.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <granite.h>
#include <gdk/gdk.h>


#define MAYA_TYPE_CONTACT_IMAGE (maya_contact_image_get_type ())
#define MAYA_CONTACT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_TYPE_CONTACT_IMAGE, MayaContactImage))
#define MAYA_CONTACT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_TYPE_CONTACT_IMAGE, MayaContactImageClass))
#define MAYA_IS_CONTACT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_TYPE_CONTACT_IMAGE))
#define MAYA_IS_CONTACT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_TYPE_CONTACT_IMAGE))
#define MAYA_CONTACT_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_TYPE_CONTACT_IMAGE, MayaContactImageClass))

typedef struct _MayaContactImage MayaContactImage;
typedef struct _MayaContactImageClass MayaContactImageClass;
typedef struct _MayaContactImagePrivate MayaContactImagePrivate;
enum  {
	MAYA_CONTACT_IMAGE_0_PROPERTY,
	MAYA_CONTACT_IMAGE_NUM_PROPERTIES
};
static GParamSpec* maya_contact_image_properties[MAYA_CONTACT_IMAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MayaContactImage {
	GtkStack parent_instance;
	MayaContactImagePrivate * priv;
};

struct _MayaContactImageClass {
	GtkStackClass parent_class;
};

struct _MayaContactImagePrivate {
	GtkIconSize icon_size;
	GtkImage* current_image;
	gboolean default_avatar;
};

struct _Block5Data {
	int _ref_count_;
	MayaContactImage* self;
	FolksIndividual* individual;
};

struct _Block6Data {
	int _ref_count_;
	MayaContactImage* self;
	GLoadableIcon* icon;
};


static gpointer maya_contact_image_parent_class = NULL;

GType maya_contact_image_get_type (void) G_GNUC_CONST;
#define MAYA_CONTACT_IMAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MAYA_TYPE_CONTACT_IMAGE, MayaContactImagePrivate))
MayaContactImage* maya_contact_image_new (GtkIconSize icon_size,
                                          FolksIndividual* individual);
MayaContactImage* maya_contact_image_construct (GType object_type,
                                                GtkIconSize icon_size,
                                                FolksIndividual* individual);
static void maya_contact_image_show_default_avatar (MayaContactImage* self);
void maya_contact_image_add_contact (MayaContactImage* self,
                                     FolksIndividual* individual);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void maya_contact_image_show_avatar_from_loadable_icon (MayaContactImage* self,
                                                        GLoadableIcon* icon);
static void __lambda88_ (Block5Data* _data5_);
static void ___lambda88__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda87_ (Block6Data* _data6_,
                      cairo_t* cr);
static gboolean ___lambda87__gtk_widget_draw (GtkWidget* _sender,
                                       cairo_t* cr,
                                       gpointer self);
static void maya_contact_image_show_avatar_image (MayaContactImage* self,
                                           GtkImage* image);
static gboolean __lambda86_ (MayaContactImage* self,
                      cairo_t* cr);
static gboolean ___lambda86__gtk_widget_draw (GtkWidget* _sender,
                                       cairo_t* cr,
                                       gpointer self);
static void maya_contact_image_finalize (GObject * obj);


MayaContactImage*
maya_contact_image_construct (GType object_type,
                              GtkIconSize icon_size,
                              FolksIndividual* individual)
{
	MayaContactImage * self = NULL;
	GtkImage* force_size_image = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	self = (MayaContactImage*) g_object_new (object_type, NULL);
	self->priv->icon_size = icon_size;
	gtk_stack_set_transition_type ((GtkStack*) self, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("avatar-default", (GtkIconSize) icon_size);
	g_object_ref_sink (_tmp0_);
	force_size_image = _tmp0_;
	_tmp1_ = force_size_image;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	maya_contact_image_show_default_avatar (self);
	if (individual != NULL) {
		maya_contact_image_add_contact (self, individual);
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (force_size_image);
	return self;
}


MayaContactImage*
maya_contact_image_new (GtkIconSize icon_size,
                        FolksIndividual* individual)
{
	return maya_contact_image_construct (MAYA_TYPE_CONTACT_IMAGE, icon_size, individual);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		MayaContactImage* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->individual);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void
__lambda88_ (Block5Data* _data5_)
{
	MayaContactImage* self;
	gboolean _tmp0_ = FALSE;
	GLoadableIcon* _tmp1_;
	GLoadableIcon* _tmp2_;
	self = _data5_->self;
	_tmp1_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _data5_->individual);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		gboolean _tmp3_;
		_tmp3_ = self->priv->default_avatar;
		_tmp0_ = _tmp3_ == TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GLoadableIcon* _tmp4_;
		GLoadableIcon* _tmp5_;
		_tmp4_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _data5_->individual);
		_tmp5_ = _tmp4_;
		maya_contact_image_show_avatar_from_loadable_icon (self, _tmp5_);
	} else {
		maya_contact_image_show_default_avatar (self);
	}
}


static void
___lambda88__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda88_ (self);
}


void
maya_contact_image_add_contact (MayaContactImage* self,
                                FolksIndividual* individual)
{
	Block5Data* _data5_;
	FolksIndividual* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GLoadableIcon* _tmp2_;
	GLoadableIcon* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (individual != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (individual);
	_g_object_unref0 (_data5_->individual);
	_data5_->individual = _tmp0_;
	_tmp2_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _data5_->individual);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		gboolean _tmp4_;
		_tmp4_ = self->priv->default_avatar;
		_tmp1_ = _tmp4_ == TRUE;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GLoadableIcon* _tmp5_;
		GLoadableIcon* _tmp6_;
		_tmp5_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _data5_->individual);
		_tmp6_ = _tmp5_;
		maya_contact_image_show_avatar_from_loadable_icon (self, _tmp6_);
	}
	g_signal_connect_data ((GObject*) _data5_->individual, "notify::avatar", (GCallback) ___lambda88__g_object_notify, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}


static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		MayaContactImage* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->icon);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static gboolean
__lambda87_ (Block6Data* _data6_,
             cairo_t* cr)
{
	MayaContactImage* self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	self = _data6_->self;
	g_return_val_if_fail (cr != NULL, FALSE);
	{
		gint width = 0;
		gint height = 0;
		gint size = 0;
		gint _tmp0_;
		gint _tmp1_;
		GInputStream* stream = NULL;
		gint _tmp2_;
		GInputStream* _tmp3_;
		GdkPixbuf* img_pixbuf = NULL;
		GInputStream* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkPixbuf* _tmp7_;
		gint x = 0;
		gint _tmp8_;
		gint _tmp9_;
		gint y = 0;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		GdkPixbuf* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		width = gtk_widget_get_allocated_width ((GtkWidget*) self);
		height = gtk_widget_get_allocated_height ((GtkWidget*) self);
		_tmp0_ = width;
		_tmp1_ = height;
		size = (gint) MIN ((gdouble) _tmp0_, (gdouble) _tmp1_);
		_tmp2_ = size;
		_tmp3_ = g_loadable_icon_load (_data6_->icon, _tmp2_, NULL, NULL, &_inner_error_);
		stream = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp4_ = stream;
		_tmp5_ = size;
		_tmp6_ = size;
		_tmp7_ = gdk_pixbuf_new_from_stream_at_scale (_tmp4_, _tmp5_, _tmp6_, TRUE, NULL, &_inner_error_);
		img_pixbuf = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (stream);
			goto __catch2_g_error;
		}
		cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
		_tmp8_ = width;
		_tmp9_ = size;
		x = (_tmp8_ - _tmp9_) / 2;
		_tmp10_ = height;
		_tmp11_ = size;
		y = (_tmp10_ - _tmp11_) / 2;
		_tmp12_ = x;
		_tmp13_ = y;
		_tmp14_ = size;
		_tmp15_ = size;
		_tmp16_ = size;
		granite_drawing_utilities_cairo_rounded_rectangle (cr, (gdouble) _tmp12_, (gdouble) _tmp13_, (gdouble) _tmp14_, (gdouble) _tmp15_, (gdouble) (_tmp16_ / 2));
		_tmp17_ = img_pixbuf;
		_tmp18_ = x;
		_tmp19_ = y;
		gdk_cairo_set_source_pixbuf (cr, _tmp17_, (gdouble) _tmp18_, (gdouble) _tmp19_);
		cairo_fill_preserve (cr);
		cairo_set_line_width (cr, (gdouble) 0);
		cairo_set_source_rgba (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.3);
		cairo_stroke (cr);
		_g_object_unref0 (img_pixbuf);
		_g_object_unref0 (stream);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		g_critical ("ContactImage.vala:77: %s", _tmp21_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp22_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp22_;
	}
	result = TRUE;
	return result;
}


static gboolean
___lambda87__gtk_widget_draw (GtkWidget* _sender,
                              cairo_t* cr,
                              gpointer self)
{
	gboolean result;
	result = __lambda87_ (self, cr);
	return result;
}


static void
maya_contact_image_show_avatar_from_loadable_icon (MayaContactImage* self,
                                                   GLoadableIcon* icon)
{
	Block6Data* _data6_;
	GLoadableIcon* _tmp0_;
	GtkImage* image = NULL;
	GtkImage* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (icon);
	_g_object_unref0 (_data6_->icon);
	_data6_->icon = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp1_);
	image = _tmp1_;
	g_signal_connect_data ((GtkWidget*) image, "draw", (GCallback) ___lambda87__gtk_widget_draw, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	maya_contact_image_show_avatar_image (self, image);
	_g_object_unref0 (image);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}


static gboolean
__lambda86_ (MayaContactImage* self,
             cairo_t* cr)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (cr != NULL, FALSE);
	{
		gint width = 0;
		gint height = 0;
		gint size = 0;
		gint _tmp0_;
		gint _tmp1_;
		GdkPixbuf* img_pixbuf = NULL;
		GtkIconTheme* _tmp2_;
		gint _tmp3_;
		GdkPixbuf* _tmp4_;
		gint x = 0;
		gint _tmp5_;
		gint _tmp6_;
		gint y = 0;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		GdkPixbuf* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		width = gtk_widget_get_allocated_width ((GtkWidget*) self);
		height = gtk_widget_get_allocated_height ((GtkWidget*) self);
		_tmp0_ = width;
		_tmp1_ = height;
		size = (gint) MIN ((gdouble) _tmp0_, (gdouble) _tmp1_);
		_tmp2_ = gtk_icon_theme_get_default ();
		_tmp3_ = size;
		_tmp4_ = gtk_icon_theme_load_icon (_tmp2_, "avatar-default", _tmp3_, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error_);
		img_pixbuf = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch3_g_error;
		}
		cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
		_tmp5_ = width;
		_tmp6_ = size;
		x = (_tmp5_ - _tmp6_) / 2;
		_tmp7_ = height;
		_tmp8_ = size;
		y = (_tmp7_ - _tmp8_) / 2;
		_tmp9_ = x;
		_tmp10_ = y;
		_tmp11_ = size;
		_tmp12_ = size;
		_tmp13_ = size;
		granite_drawing_utilities_cairo_rounded_rectangle (cr, (gdouble) _tmp9_, (gdouble) _tmp10_, (gdouble) _tmp11_, (gdouble) _tmp12_, (gdouble) (_tmp13_ / 2));
		_tmp14_ = img_pixbuf;
		_tmp15_ = x;
		_tmp16_ = y;
		gdk_cairo_set_source_pixbuf (cr, _tmp14_, (gdouble) _tmp15_, (gdouble) _tmp16_);
		cairo_fill_preserve (cr);
		cairo_set_line_width (cr, (gdouble) 0);
		cairo_set_source_rgba (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.3);
		cairo_stroke (cr);
		_g_object_unref0 (img_pixbuf);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		g_critical ("ContactImage.vala:104: %s", _tmp18_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp19_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp19_;
	}
	result = TRUE;
	return result;
}


static gboolean
___lambda86__gtk_widget_draw (GtkWidget* _sender,
                              cairo_t* cr,
                              gpointer self)
{
	gboolean result;
	result = __lambda86_ ((MayaContactImage*) self, cr);
	return result;
}


static void
maya_contact_image_show_default_avatar (MayaContactImage* self)
{
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp0_);
	image = _tmp0_;
	g_signal_connect_object ((GtkWidget*) image, "draw", (GCallback) ___lambda86__gtk_widget_draw, self, 0);
	maya_contact_image_show_avatar_image (self, image);
	self->priv->default_avatar = TRUE;
	_g_object_unref0 (image);
}


static void
maya_contact_image_show_avatar_image (MayaContactImage* self,
                                      GtkImage* image)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (image != NULL);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) image);
	gtk_widget_show ((GtkWidget*) image);
	gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) image);
	_tmp0_ = self->priv->current_image;
	if (_tmp0_ != NULL) {
		GtkImage* _tmp1_;
		_tmp1_ = self->priv->current_image;
		gtk_widget_destroy ((GtkWidget*) _tmp1_);
	}
	_tmp2_ = _g_object_ref0 (image);
	_g_object_unref0 (self->priv->current_image);
	self->priv->current_image = _tmp2_;
}


static void
maya_contact_image_class_init (MayaContactImageClass * klass)
{
	maya_contact_image_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MayaContactImagePrivate));
	G_OBJECT_CLASS (klass)->finalize = maya_contact_image_finalize;
}


static void
maya_contact_image_instance_init (MayaContactImage * self)
{
	self->priv = MAYA_CONTACT_IMAGE_GET_PRIVATE (self);
	self->priv->current_image = NULL;
	self->priv->default_avatar = TRUE;
}


static void
maya_contact_image_finalize (GObject * obj)
{
	MayaContactImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_CONTACT_IMAGE, MayaContactImage);
	_g_object_unref0 (self->priv->current_image);
	G_OBJECT_CLASS (maya_contact_image_parent_class)->finalize (obj);
}


GType
maya_contact_image_get_type (void)
{
	static volatile gsize maya_contact_image_type_id__volatile = 0;
	if (g_once_init_enter (&maya_contact_image_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MayaContactImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_contact_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaContactImage), 0, (GInstanceInitFunc) maya_contact_image_instance_init, NULL };
		GType maya_contact_image_type_id;
		maya_contact_image_type_id = g_type_register_static (gtk_stack_get_type (), "MayaContactImage", &g_define_type_info, 0);
		g_once_init_leave (&maya_contact_image_type_id__volatile, maya_contact_image_type_id);
	}
	return maya_contact_image_type_id__volatile;
}



