/* Header.c generated by valac 0.40.8, the Vala compiler
 * generated from Header.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011-2015 Maya Developers (http://launchpad.net/maya)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Maxwell Barvian
 *              Corentin Noël <corentin@elementaryos.org>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "elementary-calendar.h"
#include <glib/gi18n-lib.h>


#define MAYA_VIEW_TYPE_HEADER (maya_view_header_get_type ())
#define MAYA_VIEW_HEADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_VIEW_TYPE_HEADER, MayaViewHeader))
#define MAYA_VIEW_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_VIEW_TYPE_HEADER, MayaViewHeaderClass))
#define MAYA_VIEW_IS_HEADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_VIEW_TYPE_HEADER))
#define MAYA_VIEW_IS_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_VIEW_TYPE_HEADER))
#define MAYA_VIEW_HEADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_VIEW_TYPE_HEADER, MayaViewHeaderClass))

typedef struct _MayaViewHeader MayaViewHeader;
typedef struct _MayaViewHeaderClass MayaViewHeaderClass;
typedef struct _MayaViewHeaderPrivate MayaViewHeaderPrivate;
enum  {
	MAYA_VIEW_HEADER_0_PROPERTY,
	MAYA_VIEW_HEADER_NUM_PROPERTIES
};
static GParamSpec* maya_view_header_properties[MAYA_VIEW_HEADER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MayaViewHeader {
	GtkEventBox parent_instance;
	MayaViewHeaderPrivate * priv;
};

struct _MayaViewHeaderClass {
	GtkEventBoxClass parent_class;
};

struct _MayaViewHeaderPrivate {
	GtkGrid* header_grid;
	GtkLabel** labels;
	gint labels_length1;
	gint _labels_size_;
};


static gpointer maya_view_header_parent_class = NULL;

GType maya_view_header_get_type (void) G_GNUC_CONST;
#define MAYA_VIEW_HEADER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MAYA_VIEW_TYPE_HEADER, MayaViewHeaderPrivate))
MayaViewHeader* maya_view_header_new (void);
MayaViewHeader* maya_view_header_construct (GType object_type);
static gboolean __lambda24_ (MayaViewHeader* self,
                      GdkEventButton* event);
static void ___lambda25_ (MayaViewHeader* self);
static void ____lambda25__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static gboolean ___lambda24__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
void maya_view_header_update_columns (MayaViewHeader* self,
                                      gint week_starts_on);
static void maya_view_header_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
___lambda25_ (MayaViewHeader* self)
{
	maya_util_toggle_show_weeks ();
}


static void
____lambda25__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	___lambda25_ ((MayaViewHeader*) self);
}


static gboolean
__lambda24_ (MayaViewHeader* self,
             GdkEventButton* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = event->type;
	if (_tmp1_ == GDK_BUTTON_PRESS) {
		guint _tmp2_;
		_tmp2_ = event->button;
		_tmp0_ = _tmp2_ == ((guint) GDK_BUTTON_SECONDARY);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkMenu* menu = NULL;
		GtkMenu* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenuItem* show_weeks_menuitem = NULL;
		GtkMenuItem* _tmp5_;
		GtkMenuItem* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenu* _tmp11_;
		GtkMenu* _tmp12_;
		_tmp3_ = (GtkMenu*) gtk_menu_new ();
		g_object_ref_sink (_tmp3_);
		menu = _tmp3_;
		_tmp4_ = menu;
		gtk_menu_attach_to_widget (_tmp4_, (GtkWidget*) self, NULL);
		_tmp5_ = (GtkMenuItem*) gtk_menu_item_new ();
		g_object_ref_sink (_tmp5_);
		show_weeks_menuitem = _tmp5_;
		if (maya_util_show_weeks ()) {
			GtkMenuItem* _tmp6_;
			_tmp6_ = show_weeks_menuitem;
			gtk_menu_item_set_label (_tmp6_, _ ("Hide Week Numbers"));
		} else {
			GtkMenuItem* _tmp7_;
			_tmp7_ = show_weeks_menuitem;
			gtk_menu_item_set_label (_tmp7_, _ ("Show Week Numbers"));
		}
		_tmp8_ = show_weeks_menuitem;
		g_signal_connect_object (_tmp8_, "activate", (GCallback) ____lambda25__gtk_menu_item_activate, self, 0);
		_tmp9_ = menu;
		_tmp10_ = show_weeks_menuitem;
		gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
		_tmp11_ = menu;
		gtk_widget_show_all ((GtkWidget*) _tmp11_);
		_tmp12_ = menu;
		gtk_menu_popup_at_pointer (_tmp12_, (GdkEvent*) event);
		_g_object_unref0 (show_weeks_menuitem);
		_g_object_unref0 (menu);
	}
	result = FALSE;
	return result;
}


static gboolean
___lambda24__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda24_ ((MayaViewHeader*) self, event);
	return result;
}


MayaViewHeader*
maya_view_header_construct (GType object_type)
{
	MayaViewHeader * self = NULL;
	GdkEventMask _tmp0_;
	GdkEventMask _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	GtkGrid* _tmp5_;
	GtkGrid* _tmp6_;
	GtkGrid* _tmp7_;
	GtkGrid* _tmp8_;
	GtkCssProvider* style_provider = NULL;
	GtkCssProvider* _tmp9_;
	GtkCssProvider* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkCssProvider* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkLabel** _tmp14_;
	GtkGrid* _tmp39_;
	self = (MayaViewHeader*) g_object_new (object_type, NULL);
	_tmp0_ = gtk_widget_get_events ((GtkWidget*) self);
	_tmp1_ = _tmp0_;
	gtk_widget_set_events ((GtkWidget*) self, _tmp1_ | GDK_BUTTON_PRESS_MASK);
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->header_grid);
	self->priv->header_grid = _tmp2_;
	_tmp3_ = self->priv->header_grid;
	gtk_grid_insert_column (_tmp3_, 7);
	_tmp4_ = self->priv->header_grid;
	gtk_grid_insert_row (_tmp4_, 1);
	_tmp5_ = self->priv->header_grid;
	gtk_grid_set_column_homogeneous (_tmp5_, TRUE);
	_tmp6_ = self->priv->header_grid;
	gtk_grid_set_row_homogeneous (_tmp6_, TRUE);
	_tmp7_ = self->priv->header_grid;
	gtk_grid_set_column_spacing (_tmp7_, 0);
	_tmp8_ = self->priv->header_grid;
	gtk_grid_set_row_spacing (_tmp8_, 0);
	_tmp9_ = maya_util_css_get_css_provider ();
	_tmp10_ = _g_object_ref0 (_tmp9_);
	style_provider = _tmp10_;
	gtk_event_box_set_visible_window ((GtkEventBox*) self, TRUE);
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp12_ = style_provider;
	gtk_style_context_add_provider (_tmp11_, (GtkStyleProvider*) _tmp12_, (guint) 600);
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp13_, "header");
	_tmp14_ = g_new0 (GtkLabel*, 7 + 1);
	self->priv->labels = (_vala_array_free (self->priv->labels, self->priv->labels_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->labels = _tmp14_;
	self->priv->labels_length1 = 7;
	self->priv->_labels_size_ = self->priv->labels_length1;
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				gint _tmp17_;
				GtkLabel** _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				GtkLabel* _tmp20_;
				GtkLabel* _tmp21_;
				GtkLabel** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_;
				GtkLabel* _tmp24_;
				GtkLabel** _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_;
				GtkLabel* _tmp27_;
				GtkStyleContext* _tmp28_;
				GtkCssProvider* _tmp29_;
				GtkLabel** _tmp30_;
				gint _tmp30__length1;
				gint _tmp31_;
				GtkLabel* _tmp32_;
				GtkStyleContext* _tmp33_;
				GtkGrid* _tmp34_;
				GtkLabel** _tmp35_;
				gint _tmp35__length1;
				gint _tmp36_;
				GtkLabel* _tmp37_;
				gint _tmp38_;
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = c;
					c = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				_tmp17_ = c;
				if (!(_tmp17_ < 7)) {
					break;
				}
				_tmp18_ = self->priv->labels;
				_tmp18__length1 = self->priv->labels_length1;
				_tmp19_ = c;
				_tmp20_ = (GtkLabel*) gtk_label_new ("");
				g_object_ref_sink (_tmp20_);
				_g_object_unref0 (_tmp18_[_tmp19_]);
				_tmp18_[_tmp19_] = _tmp20_;
				_tmp21_ = _tmp18_[_tmp19_];
				_tmp22_ = self->priv->labels;
				_tmp22__length1 = self->priv->labels_length1;
				_tmp23_ = c;
				_tmp24_ = _tmp22_[_tmp23_];
				gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, TRUE);
				_tmp25_ = self->priv->labels;
				_tmp25__length1 = self->priv->labels_length1;
				_tmp26_ = c;
				_tmp27_ = _tmp25_[_tmp26_];
				_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
				_tmp29_ = style_provider;
				gtk_style_context_add_provider (_tmp28_, (GtkStyleProvider*) _tmp29_, (guint) 600);
				_tmp30_ = self->priv->labels;
				_tmp30__length1 = self->priv->labels_length1;
				_tmp31_ = c;
				_tmp32_ = _tmp30_[_tmp31_];
				_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
				gtk_style_context_add_class (_tmp33_, "daylabel");
				_tmp34_ = self->priv->header_grid;
				_tmp35_ = self->priv->labels;
				_tmp35__length1 = self->priv->labels_length1;
				_tmp36_ = c;
				_tmp37_ = _tmp35_[_tmp36_];
				_tmp38_ = c;
				gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp37_, _tmp38_, 0, 1, 1);
			}
		}
	}
	_tmp39_ = self->priv->header_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp39_);
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) ___lambda24__gtk_widget_button_press_event, self, 0);
	_g_object_unref0 (style_provider);
	return self;
}


MayaViewHeader*
maya_view_header_new (void)
{
	return maya_view_header_construct (MAYA_VIEW_TYPE_HEADER);
}


void
maya_view_header_update_columns (MayaViewHeader* self,
                                 gint week_starts_on)
{
	GDateTime* date = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GtkLabel** _tmp7_;
	gint _tmp7__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = maya_util_strip_time (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_date_time_unref0 (_tmp1_);
	date = _tmp3_;
	_tmp4_ = date;
	_tmp5_ = date;
	_tmp6_ = g_date_time_add_days (_tmp4_, week_starts_on - g_date_time_get_day_of_week (_tmp5_));
	_g_date_time_unref0 (date);
	date = _tmp6_;
	_tmp7_ = self->priv->labels;
	_tmp7__length1 = self->priv->labels_length1;
	{
		GtkLabel** label_collection = NULL;
		gint label_collection_length1 = 0;
		gint _label_collection_size_ = 0;
		gint label_it = 0;
		label_collection = _tmp7_;
		label_collection_length1 = _tmp7__length1;
		for (label_it = 0; label_it < _tmp7__length1; label_it = label_it + 1) {
			GtkLabel* _tmp8_;
			GtkLabel* label = NULL;
			_tmp8_ = _g_object_ref0 (label_collection[label_it]);
			label = _tmp8_;
			{
				GtkLabel* _tmp9_;
				GDateTime* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GDateTime* _tmp13_;
				GDateTime* _tmp14_;
				_tmp9_ = label;
				_tmp10_ = date;
				_tmp11_ = g_date_time_format (_tmp10_, "%a");
				_tmp12_ = _tmp11_;
				gtk_label_set_label (_tmp9_, _tmp12_);
				_g_free0 (_tmp12_);
				_tmp13_ = date;
				_tmp14_ = g_date_time_add_days (_tmp13_, 1);
				_g_date_time_unref0 (date);
				date = _tmp14_;
				_g_object_unref0 (label);
			}
		}
	}
	_g_date_time_unref0 (date);
}


static void
maya_view_header_class_init (MayaViewHeaderClass * klass)
{
	maya_view_header_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MayaViewHeaderPrivate));
	G_OBJECT_CLASS (klass)->finalize = maya_view_header_finalize;
}


static void
maya_view_header_instance_init (MayaViewHeader * self)
{
	self->priv = MAYA_VIEW_HEADER_GET_PRIVATE (self);
}


static void
maya_view_header_finalize (GObject * obj)
{
	MayaViewHeader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_VIEW_TYPE_HEADER, MayaViewHeader);
	_g_object_unref0 (self->priv->header_grid);
	self->priv->labels = (_vala_array_free (self->priv->labels, self->priv->labels_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (maya_view_header_parent_class)->finalize (obj);
}


/**
 * Represents the header at the top of the calendar grid.
 */
GType
maya_view_header_get_type (void)
{
	static volatile gsize maya_view_header_type_id__volatile = 0;
	if (g_once_init_enter (&maya_view_header_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MayaViewHeaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_view_header_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaViewHeader), 0, (GInstanceInitFunc) maya_view_header_instance_init, NULL };
		GType maya_view_header_type_id;
		maya_view_header_type_id = g_type_register_static (gtk_event_box_get_type (), "MayaViewHeader", &g_define_type_info, 0);
		g_once_init_leave (&maya_view_header_type_id__volatile, maya_view_header_type_id);
	}
	return maya_view_header_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



