/* SourceDialog.c generated by valac 0.40.8, the Vala compiler
 * generated from SourceDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011-2015 Maya Developers (http://launchpad.net/maya)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Jaap Broekhuizen
 *              Corentin Noël <corentin@elementaryos.org>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "elementary-calendar.h"
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <libedataserver/libedataserver.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define MAYA_VIEW_TYPE_SOURCE_DIALOG (maya_view_source_dialog_get_type ())
#define MAYA_VIEW_SOURCE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog))
#define MAYA_VIEW_SOURCE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialogClass))
#define MAYA_VIEW_IS_SOURCE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_VIEW_TYPE_SOURCE_DIALOG))
#define MAYA_VIEW_IS_SOURCE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_VIEW_TYPE_SOURCE_DIALOG))
#define MAYA_VIEW_SOURCE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialogClass))

typedef struct _MayaViewSourceDialog MayaViewSourceDialog;
typedef struct _MayaViewSourceDialogClass MayaViewSourceDialogClass;
typedef struct _MayaViewSourceDialogPrivate MayaViewSourceDialogPrivate;

#define MAYA_VIEW_TYPE_EVENT_TYPE (maya_view_event_type_get_type ())
enum  {
	MAYA_VIEW_SOURCE_DIALOG_0_PROPERTY,
	MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY,
	MAYA_VIEW_SOURCE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* maya_view_source_dialog_properties[MAYA_VIEW_SOURCE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block24Data Block24Data;
enum  {
	MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL,
	MAYA_VIEW_SOURCE_DIALOG_NUM_SIGNALS
};
static guint maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_NUM_SIGNALS] = {0};

struct _MayaViewSourceDialog {
	GtkGrid parent_instance;
	MayaViewSourceDialogPrivate * priv;
};

struct _MayaViewSourceDialogClass {
	GtkGridClass parent_class;
};

typedef enum  {
	MAYA_VIEW_EVENT_TYPE_ADD,
	MAYA_VIEW_EVENT_TYPE_EDIT
} MayaViewEventType;

struct _MayaViewSourceDialogPrivate {
	MayaViewEventType _event_type;
	GtkEntry* name_entry;
	GtkColorButton* color_button;
	gboolean set_as_default;
	MayaBackend* current_backend;
	GeeCollection* backend_widgets;
	GtkGrid* main_grid;
	GeeHashMap* widgets_checked;
	GtkButton* create_button;
	GtkComboBox* type_combobox;
	GtkListStore* list_store;
	ESource* source;
};

struct _Block24Data {
	int _ref_count_;
	MayaViewSourceDialog* self;
	MayaPlacementWidget* widget;
};


static gpointer maya_view_source_dialog_parent_class = NULL;

GType maya_view_source_dialog_get_type (void) G_GNUC_CONST;
GType maya_view_event_type_get_type (void) G_GNUC_CONST;
#define MAYA_VIEW_SOURCE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialogPrivate))
MayaViewSourceDialog* maya_view_source_dialog_new (void);
MayaViewSourceDialog* maya_view_source_dialog_construct (GType object_type);
void maya_view_source_dialog_save (MayaViewSourceDialog* self);
static void _maya_view_source_dialog_save_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void __lambda60_ (MayaViewSourceDialog* self);
static void ___lambda60__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda61_ (MayaViewSourceDialog* self);
static void maya_view_source_dialog_check_can_validate (MayaViewSourceDialog* self);
static void ___lambda61__gtk_editable_changed (GtkEditable* _sender,
                                        gpointer self);
static void __lambda62_ (MayaViewSourceDialog* self);
static void maya_view_source_dialog_remove_backend_widgets (MayaViewSourceDialog* self);
static void maya_view_source_dialog_add_backend_widgets (MayaViewSourceDialog* self);
static void ___lambda62__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
static void __lambda64_ (MayaViewSourceDialog* self);
static void ___lambda64__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
void maya_view_source_dialog_set_source (MayaViewSourceDialog* self,
                                         ESource* source);
static void maya_view_source_dialog_set_event_type (MayaViewSourceDialog* self,
                                             MayaViewEventType value);
static gboolean maya_view_source_dialog_tree_foreach (MayaViewSourceDialog* self,
                                               GtkTreeModel* model,
                                               GtkTreePath* path,
                                               GtkTreeIter* iter);
static gboolean _maya_view_source_dialog_tree_foreach_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                            GtkTreePath* path,
                                                                            GtkTreeIter* iter,
                                                                            gpointer self);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void _____lambda63_ (Block24Data* _data24_);
static void maya_view_source_dialog_entry_changed (MayaViewSourceDialog* self,
                                            MayaPlacementWidget* widget);
static void ______lambda63__gtk_editable_changed (GtkEditable* _sender,
                                           gpointer self);
MayaViewEventType maya_view_source_dialog_get_event_type (MayaViewSourceDialog* self);
static void maya_view_source_dialog_finalize (GObject * obj);
static void _vala_maya_view_source_dialog_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_maya_view_source_dialog_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);


static void
_maya_view_source_dialog_save_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	maya_view_source_dialog_save ((MayaViewSourceDialog*) self);
}


static void
__lambda60_ (MayaViewSourceDialog* self)
{
	g_signal_emit (self, maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL], 0);
}


static void
___lambda60__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda60_ ((MayaViewSourceDialog*) self);
}


static void
__lambda61_ (MayaViewSourceDialog* self)
{
	maya_view_source_dialog_check_can_validate (self);
}


static void
___lambda61__gtk_editable_changed (GtkEditable* _sender,
                                   gpointer self)
{
	__lambda61_ ((MayaViewSourceDialog*) self);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
__lambda62_ (MayaViewSourceDialog* self)
{
	GValue backend = {0};
	GtkTreeIter b_iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	GValue _tmp5_;
	MayaBackend* _tmp6_;
	GValue _tmp7_;
	ESource* _tmp8_;
	GeeCollection* _tmp9_;
	_tmp0_ = self->priv->type_combobox;
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	b_iter = _tmp1_;
	_tmp2_ = self->priv->list_store;
	_tmp3_ = b_iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, 1, &_tmp4_);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
	backend = _tmp4_;
	_tmp5_ = backend;
	_tmp6_ = _g_object_ref0 (g_value_get_object (&_tmp5_));
	_g_object_unref0 (self->priv->current_backend);
	self->priv->current_backend = _tmp6_;
	maya_view_source_dialog_remove_backend_widgets (self);
	_tmp7_ = backend;
	_tmp8_ = self->priv->source;
	_tmp9_ = maya_backend_get_new_calendar_widget (g_value_get_object (&_tmp7_), _tmp8_);
	_g_object_unref0 (self->priv->backend_widgets);
	self->priv->backend_widgets = _tmp9_;
	maya_view_source_dialog_add_backend_widgets (self);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
}


static void
___lambda62__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda62_ ((MayaViewSourceDialog*) self);
}


static void
__lambda64_ (MayaViewSourceDialog* self)
{
	gboolean _tmp0_;
	_tmp0_ = self->priv->set_as_default;
	self->priv->set_as_default = !_tmp0_;
}


static void
___lambda64__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda64_ ((MayaViewSourceDialog*) self);
}


MayaViewSourceDialog*
maya_view_source_dialog_construct (GType object_type)
{
	MayaViewSourceDialog * self = NULL;
	GeeHashMap* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	GtkButtonBox* buttonbox = NULL;
	GtkButtonBox* _tmp4_;
	GtkButtonBox* _tmp5_;
	GtkButton* cancel_button = NULL;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButtonBox* _tmp11_;
	GtkButton* _tmp12_;
	GtkButtonBox* _tmp13_;
	GtkButton* _tmp14_;
	GtkLabel* name_label = NULL;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkEntry* _tmp19_;
	GtkListStore* _tmp20_;
	GtkListStore* _tmp21_;
	GtkComboBox* _tmp22_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp23_;
	GtkComboBox* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkComboBox* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GtkComboBox* _tmp28_;
	GtkLabel* type_label = NULL;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkTreeIter iter = {0};
	MayaBackendsManager* backends_manager = NULL;
	MayaBackendsManager* _tmp31_;
	MayaBackendsManager* _tmp53_;
	GeeArrayList* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	GtkComboBox* _tmp59_;
	GdkRGBA rgba = {0};
	GtkLabel* color_label = NULL;
	GtkLabel* _tmp60_;
	GdkRGBA _tmp61_;
	GtkColorButton* _tmp62_;
	GtkColorButton* _tmp63_;
	GtkCheckButton* check_button = NULL;
	GtkCheckButton* _tmp64_;
	GtkGrid* _tmp65_;
	GtkLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkComboBox* _tmp68_;
	GtkGrid* _tmp69_;
	GtkLabel* _tmp70_;
	GtkGrid* _tmp71_;
	GtkEntry* _tmp72_;
	GtkGrid* _tmp73_;
	GtkGrid* _tmp74_;
	GtkColorButton* _tmp75_;
	GtkGrid* _tmp76_;
	GtkGrid* _tmp77_;
	GtkGrid* fake_label = NULL;
	GtkGrid* _tmp78_;
	GtkButtonBox* _tmp79_;
	self = (MayaViewSourceDialog*) g_object_new (object_type, NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BOOLEAN, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->widgets_checked);
	self->priv->widgets_checked = _tmp0_;
	_tmp1_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->main_grid);
	self->priv->main_grid = _tmp1_;
	_tmp2_ = self->priv->main_grid;
	gtk_grid_set_row_spacing (_tmp2_, (guint) 6);
	_tmp3_ = self->priv->main_grid;
	gtk_grid_set_column_spacing (_tmp3_, (guint) 12);
	gtk_widget_set_margin_start ((GtkWidget*) self, 6);
	gtk_widget_set_margin_end ((GtkWidget*) self, 6);
	gtk_widget_set_margin_top ((GtkWidget*) self, 6);
	gtk_grid_set_row_spacing ((GtkGrid*) self, (guint) 6);
	gtk_grid_set_column_spacing ((GtkGrid*) self, (guint) 12);
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
	_tmp4_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp4_);
	buttonbox = _tmp4_;
	_tmp5_ = buttonbox;
	gtk_button_box_set_layout (_tmp5_, GTK_BUTTONBOX_END);
	_tmp6_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
	g_object_ref_sink (_tmp6_);
	cancel_button = _tmp6_;
	_tmp7_ = cancel_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp7_, 6);
	_tmp8_ = (GtkButton*) gtk_button_new_with_label (_ ("Create"));
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->create_button);
	self->priv->create_button = _tmp8_;
	_tmp9_ = self->priv->create_button;
	g_signal_connect_object (_tmp9_, "clicked", (GCallback) _maya_view_source_dialog_save_gtk_button_clicked, self, 0);
	_tmp10_ = cancel_button;
	g_signal_connect_object (_tmp10_, "clicked", (GCallback) ___lambda60__gtk_button_clicked, self, 0);
	_tmp11_ = buttonbox;
	_tmp12_ = cancel_button;
	gtk_box_pack_end ((GtkBox*) _tmp11_, (GtkWidget*) _tmp12_, TRUE, TRUE, (guint) 0);
	_tmp13_ = buttonbox;
	_tmp14_ = self->priv->create_button;
	gtk_box_pack_end ((GtkBox*) _tmp13_, (GtkWidget*) _tmp14_, TRUE, TRUE, (guint) 0);
	_tmp15_ = (GtkLabel*) gtk_label_new (_ ("Name:"));
	g_object_ref_sink (_tmp15_);
	name_label = _tmp15_;
	_tmp16_ = name_label;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_misc_get_type (), GtkMisc), "xalign", 1.0f, NULL);
	_tmp17_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->name_entry);
	self->priv->name_entry = _tmp17_;
	_tmp18_ = self->priv->name_entry;
	gtk_entry_set_placeholder_text (_tmp18_, _ ("Calendar Name"));
	_tmp19_ = self->priv->name_entry;
	g_signal_connect_object ((GtkEditable*) _tmp19_, "changed", (GCallback) ___lambda61__gtk_editable_changed, self, 0);
	_tmp20_ = gtk_list_store_new (2, G_TYPE_STRING, MAYA_TYPE_BACKEND, -1);
	_g_object_unref0 (self->priv->list_store);
	self->priv->list_store = _tmp20_;
	_tmp21_ = self->priv->list_store;
	_tmp22_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp21_);
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->type_combobox);
	self->priv->type_combobox = _tmp22_;
	_tmp23_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp23_);
	renderer = _tmp23_;
	_tmp24_ = self->priv->type_combobox;
	_tmp25_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp24_, (GtkCellRenderer*) _tmp25_, TRUE);
	_tmp26_ = self->priv->type_combobox;
	_tmp27_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp26_, (GtkCellRenderer*) _tmp27_, "text", 0);
	_tmp28_ = self->priv->type_combobox;
	g_signal_connect_object (_tmp28_, "changed", (GCallback) ___lambda62__gtk_combo_box_changed, self, 0);
	_tmp29_ = (GtkLabel*) gtk_label_new (_ ("Type:"));
	g_object_ref_sink (_tmp29_);
	type_label = _tmp29_;
	_tmp30_ = type_label;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_misc_get_type (), GtkMisc), "xalign", 1.0f, NULL);
	_tmp31_ = maya_backends_manager_get_default ();
	backends_manager = _tmp31_;
	{
		GeeArrayList* _backend_list = NULL;
		MayaBackendsManager* _tmp32_;
		GeeArrayList* _tmp33_;
		GeeArrayList* _tmp34_;
		gint _backend_size = 0;
		GeeArrayList* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		gint _backend_index = 0;
		_tmp32_ = backends_manager;
		_tmp33_ = _tmp32_->backends;
		_tmp34_ = _g_object_ref0 (_tmp33_);
		_backend_list = _tmp34_;
		_tmp35_ = _backend_list;
		_tmp36_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp35_);
		_tmp37_ = _tmp36_;
		_backend_size = _tmp37_;
		_backend_index = -1;
		while (TRUE) {
			gint _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			MayaBackend* backend = NULL;
			GeeArrayList* _tmp41_;
			gint _tmp42_;
			gpointer _tmp43_;
			MayaBackend* _tmp44_;
			GtkListStore* _tmp45_;
			GtkTreeIter _tmp46_ = {0};
			GtkListStore* _tmp47_;
			GtkTreeIter _tmp48_;
			MayaBackend* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			MayaBackend* _tmp52_;
			_tmp38_ = _backend_index;
			_backend_index = _tmp38_ + 1;
			_tmp39_ = _backend_index;
			_tmp40_ = _backend_size;
			if (!(_tmp39_ < _tmp40_)) {
				break;
			}
			_tmp41_ = _backend_list;
			_tmp42_ = _backend_index;
			_tmp43_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, _tmp42_);
			_tmp44_ = _g_object_ref0 ((MayaBackend*) _tmp43_);
			backend = _tmp44_;
			_tmp45_ = self->priv->list_store;
			gtk_list_store_append (_tmp45_, &_tmp46_);
			iter = _tmp46_;
			_tmp47_ = self->priv->list_store;
			_tmp48_ = iter;
			_tmp49_ = backend;
			_tmp50_ = maya_backend_get_name (_tmp49_);
			_tmp51_ = _tmp50_;
			_tmp52_ = backend;
			gtk_list_store_set (_tmp47_, &_tmp48_, 0, _tmp51_, 1, _tmp52_, -1);
			_g_free0 (_tmp51_);
			_g_object_unref0 (backend);
		}
		_g_object_unref0 (_backend_list);
	}
	_tmp53_ = backends_manager;
	_tmp54_ = _tmp53_->backends;
	_tmp55_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp54_);
	_tmp56_ = _tmp55_;
	if (_tmp56_ <= 1) {
		GtkComboBox* _tmp57_;
		GtkLabel* _tmp58_;
		_tmp57_ = self->priv->type_combobox;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp57_, TRUE);
		_tmp58_ = type_label;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp58_, TRUE);
	}
	_tmp59_ = self->priv->type_combobox;
	gtk_combo_box_set_active (_tmp59_, 0);
	memset (&rgba, 0, sizeof (GdkRGBA));
	rgba.red = 0.13;
	rgba.green = 0.42;
	rgba.blue = 0.70;
	rgba.alpha = (gdouble) 1;
	_tmp60_ = (GtkLabel*) gtk_label_new (_ ("Color:"));
	g_object_ref_sink (_tmp60_);
	color_label = _tmp60_;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (color_label, gtk_misc_get_type (), GtkMisc), "xalign", 1.0f, NULL);
	_tmp61_ = rgba;
	_tmp62_ = (GtkColorButton*) gtk_color_button_new_with_rgba (&_tmp61_);
	g_object_ref_sink (_tmp62_);
	_g_object_unref0 (self->priv->color_button);
	self->priv->color_button = _tmp62_;
	_tmp63_ = self->priv->color_button;
	gtk_color_button_set_use_alpha (_tmp63_, FALSE);
	_tmp64_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Mark as default calendar"));
	g_object_ref_sink (_tmp64_);
	check_button = _tmp64_;
	g_signal_connect_object ((GtkToggleButton*) check_button, "toggled", (GCallback) ___lambda64__gtk_toggle_button_toggled, self, 0);
	_tmp65_ = self->priv->main_grid;
	_tmp66_ = type_label;
	gtk_grid_attach (_tmp65_, (GtkWidget*) _tmp66_, 0, 0, 1, 1);
	_tmp67_ = self->priv->main_grid;
	_tmp68_ = self->priv->type_combobox;
	gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, 1, 0, 1, 1);
	_tmp69_ = self->priv->main_grid;
	_tmp70_ = name_label;
	gtk_grid_attach (_tmp69_, (GtkWidget*) _tmp70_, 0, 1, 1, 1);
	_tmp71_ = self->priv->main_grid;
	_tmp72_ = self->priv->name_entry;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 1, 1, 1, 1);
	_tmp73_ = self->priv->main_grid;
	gtk_grid_attach (_tmp73_, (GtkWidget*) color_label, 0, 2, 1, 1);
	_tmp74_ = self->priv->main_grid;
	_tmp75_ = self->priv->color_button;
	gtk_grid_attach (_tmp74_, (GtkWidget*) _tmp75_, 1, 2, 1, 1);
	_tmp76_ = self->priv->main_grid;
	gtk_grid_attach (_tmp76_, (GtkWidget*) check_button, 1, 3, 1, 1);
	_tmp77_ = self->priv->main_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp77_, 0, 0, 2, 1);
	_tmp78_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp78_);
	fake_label = _tmp78_;
	g_object_set ((GtkWidget*) fake_label, "expand", TRUE, NULL);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) fake_label, 0, 1, 2, 1);
	_tmp79_ = buttonbox;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp79_, 0, 2, 2, 1);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (fake_label);
	_g_object_unref0 (check_button);
	_g_object_unref0 (color_label);
	_g_object_unref0 (backends_manager);
	_g_object_unref0 (type_label);
	_g_object_unref0 (renderer);
	_g_object_unref0 (name_label);
	_g_object_unref0 (cancel_button);
	_g_object_unref0 (buttonbox);
	return self;
}


MayaViewSourceDialog*
maya_view_source_dialog_new (void)
{
	return maya_view_source_dialog_construct (MAYA_VIEW_TYPE_SOURCE_DIALOG);
}


static gboolean
_maya_view_source_dialog_tree_foreach_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                   GtkTreePath* path,
                                                                   GtkTreeIter* iter,
                                                                   gpointer self)
{
	gboolean result;
	result = maya_view_source_dialog_tree_foreach ((MayaViewSourceDialog*) self, model, path, iter);
	return result;
}


void
maya_view_source_dialog_set_source (MayaViewSourceDialog* self,
                                    ESource* source)
{
	ESource* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (source);
	_g_object_unref0 (self->priv->source);
	self->priv->source = _tmp0_;
	if (source == NULL) {
		GtkEntry* _tmp1_;
		GtkComboBox* _tmp2_;
		GtkButton* _tmp3_;
		GdkRGBA rgba = {0};
		GtkColorButton* _tmp4_;
		GdkRGBA _tmp5_;
		maya_view_source_dialog_set_event_type (self, MAYA_VIEW_EVENT_TYPE_ADD);
		_tmp1_ = self->priv->name_entry;
		gtk_entry_set_text (_tmp1_, "");
		_tmp2_ = self->priv->type_combobox;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
		_tmp3_ = self->priv->create_button;
		gtk_button_set_label (_tmp3_, _ ("Create Calendar"));
		memset (&rgba, 0, sizeof (GdkRGBA));
		rgba.red = 0.13;
		rgba.green = 0.42;
		rgba.blue = 0.70;
		rgba.alpha = (gdouble) 1;
		_tmp4_ = self->priv->color_button;
		_tmp5_ = rgba;
		gtk_color_chooser_set_rgba ((GtkColorChooser*) _tmp4_, &_tmp5_);
	} else {
		GtkButton* _tmp6_;
		GtkEntry* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GtkComboBox* _tmp10_;
		GtkComboBox* _tmp11_;
		GtkListStore* _tmp12_;
		ESourceCalendar* cal = NULL;
		ESourceExtension* _tmp13_;
		ESourceCalendar* _tmp14_;
		GdkRGBA rgba = {0};
		ESourceCalendar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GtkColorButton* _tmp18_;
		GdkRGBA _tmp19_;
		maya_view_source_dialog_set_event_type (self, MAYA_VIEW_EVENT_TYPE_EDIT);
		_tmp6_ = self->priv->create_button;
		gtk_button_set_label (_tmp6_, _ ("Save"));
		_tmp7_ = self->priv->name_entry;
		_tmp8_ = e_source_get_display_name (source);
		_tmp9_ = _tmp8_;
		gtk_entry_set_text (_tmp7_, _tmp9_);
		_tmp10_ = self->priv->type_combobox;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
		_tmp11_ = self->priv->type_combobox;
		gtk_combo_box_set_active (_tmp11_, 0);
		_tmp12_ = self->priv->list_store;
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp12_, _maya_view_source_dialog_tree_foreach_gtk_tree_model_foreach_func, self);
		_tmp13_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
		_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, e_source_calendar_get_type (), ESourceCalendar));
		cal = _tmp14_;
		memset (&rgba, 0, sizeof (GdkRGBA));
		_tmp15_ = cal;
		_tmp16_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp15_);
		_tmp17_ = _tmp16_;
		gdk_rgba_parse (&rgba, _tmp17_);
		_g_free0 (_tmp17_);
		_tmp18_ = self->priv->color_button;
		_tmp19_ = rgba;
		gtk_color_chooser_set_rgba ((GtkColorChooser*) _tmp18_, &_tmp19_);
		_g_object_unref0 (cal);
	}
}


static gboolean
maya_view_source_dialog_tree_foreach (MayaViewSourceDialog* self,
                                      GtkTreeModel* model,
                                      GtkTreePath* path,
                                      GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GValue backend = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	MayaBackend* current_backend = NULL;
	GValue _tmp3_;
	MayaBackend* _tmp4_;
	MayaBackend* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	ESource* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->list_store;
	_tmp1_ = *iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, 1, &_tmp2_);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
	backend = _tmp2_;
	_tmp3_ = backend;
	_tmp4_ = _g_object_ref0 (g_value_get_object (&_tmp3_));
	current_backend = _tmp4_;
	_tmp5_ = current_backend;
	_tmp6_ = maya_backend_get_uid (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->source;
	_tmp9_ = e_source_dup_parent (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strcmp0 (_tmp7_, _tmp10_) == 0;
	_g_free0 (_tmp10_);
	_g_free0 (_tmp7_);
	if (_tmp11_) {
		GtkComboBox* _tmp12_;
		GtkTreeIter _tmp13_;
		GtkComboBox* _tmp14_;
		_tmp12_ = self->priv->type_combobox;
		_tmp13_ = *iter;
		gtk_combo_box_set_active_iter (_tmp12_, &_tmp13_);
		_tmp14_ = self->priv->type_combobox;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
		result = TRUE;
		_g_object_unref0 (current_backend);
		G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
		return result;
	}
	result = FALSE;
	_g_object_unref0 (current_backend);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
	return result;
}


static void
maya_view_source_dialog_remove_backend_widgets (MayaViewSourceDialog* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backend_widgets;
	if (_tmp0_ == NULL) {
		return;
	}
	{
		GeeIterator* _widget_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = self->priv->backend_widgets;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_widget_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			MayaPlacementWidget* widget = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MayaPlacementWidget* _tmp6_;
			GtkWidget* _tmp7_;
			MayaPlacementWidget* _tmp8_;
			GtkWidget* _tmp9_;
			_tmp3_ = _widget_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _widget_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			widget = (MayaPlacementWidget*) _tmp5_;
			_tmp6_ = widget;
			_tmp7_ = _tmp6_->widget;
			gtk_widget_hide (_tmp7_);
			_tmp8_ = widget;
			_tmp9_ = _tmp8_->widget;
			gtk_widget_destroy (_tmp9_);
			_g_object_unref0 (widget);
		}
		_g_object_unref0 (_widget_it);
	}
	_tmp10_ = self->priv->backend_widgets;
	gee_collection_clear (_tmp10_);
}


static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
	g_atomic_int_inc (&_data24_->_ref_count_);
	return _data24_;
}


static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
		MayaViewSourceDialog* self;
		self = _data24_->self;
		_g_object_unref0 (_data24_->widget);
		_g_object_unref0 (self);
		g_slice_free (Block24Data, _data24_);
	}
}


static void
_____lambda63_ (Block24Data* _data24_)
{
	MayaViewSourceDialog* self;
	MayaPlacementWidget* _tmp0_;
	self = _data24_->self;
	_tmp0_ = _data24_->widget;
	maya_view_source_dialog_entry_changed (self, _tmp0_);
}


static void
______lambda63__gtk_editable_changed (GtkEditable* _sender,
                                      gpointer self)
{
	_____lambda63_ (self);
}


static void
maya_view_source_dialog_add_backend_widgets (MayaViewSourceDialog* self)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->widgets_checked;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	{
		GeeIterator* _widget_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = self->priv->backend_widgets;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_widget_it = _tmp2_;
		while (TRUE) {
			Block24Data* _data24_;
			GeeIterator* _tmp3_;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GtkGrid* _tmp6_;
			MayaPlacementWidget* _tmp7_;
			GtkWidget* _tmp8_;
			MayaPlacementWidget* _tmp9_;
			gint _tmp10_;
			MayaPlacementWidget* _tmp11_;
			gint _tmp12_;
			gboolean _tmp13_ = FALSE;
			MayaPlacementWidget* _tmp14_;
			gboolean _tmp15_;
			MayaPlacementWidget* _tmp29_;
			GtkWidget* _tmp30_;
			_data24_ = g_slice_new0 (Block24Data);
			_data24_->_ref_count_ = 1;
			_data24_->self = g_object_ref (self);
			_tmp3_ = _widget_it;
			if (!gee_iterator_next (_tmp3_)) {
				block24_data_unref (_data24_);
				_data24_ = NULL;
				break;
			}
			_tmp4_ = _widget_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			_data24_->widget = (MayaPlacementWidget*) _tmp5_;
			_tmp6_ = self->priv->main_grid;
			_tmp7_ = _data24_->widget;
			_tmp8_ = _tmp7_->widget;
			_tmp9_ = _data24_->widget;
			_tmp10_ = _tmp9_->column;
			_tmp11_ = _data24_->widget;
			_tmp12_ = _tmp11_->row;
			gtk_grid_attach (_tmp6_, _tmp8_, _tmp10_, 4 + _tmp12_, 1, 1);
			_tmp14_ = _data24_->widget;
			_tmp15_ = _tmp14_->needed;
			if (_tmp15_ == TRUE) {
				MayaPlacementWidget* _tmp16_;
				GtkWidget* _tmp17_;
				_tmp16_ = _data24_->widget;
				_tmp17_ = _tmp16_->widget;
				_tmp13_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, gtk_entry_get_type ());
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				GtkEntry* entry = NULL;
				MayaPlacementWidget* _tmp18_;
				GtkWidget* _tmp19_;
				GtkEntry* _tmp20_;
				GtkEntry* _tmp21_;
				GeeHashMap* _tmp22_;
				MayaPlacementWidget* _tmp23_;
				const gchar* _tmp24_;
				MayaPlacementWidget* _tmp25_;
				GtkWidget* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				_tmp18_ = _data24_->widget;
				_tmp19_ = _tmp18_->widget;
				_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, gtk_entry_get_type ()) ? ((GtkEntry*) _tmp19_) : NULL);
				entry = _tmp20_;
				_tmp21_ = entry;
				g_signal_connect_data ((GtkEditable*) _tmp21_, "changed", (GCallback) ______lambda63__gtk_editable_changed, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
				_tmp22_ = self->priv->widgets_checked;
				_tmp23_ = _data24_->widget;
				_tmp24_ = _tmp23_->ref_name;
				_tmp25_ = _data24_->widget;
				_tmp26_ = _tmp25_->widget;
				_tmp27_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_entry_get_type (), GtkEntry));
				_tmp28_ = _tmp27_;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, _tmp24_, (gpointer) ((gintptr) (g_strcmp0 (_tmp28_, "") != 0)));
				_g_object_unref0 (entry);
			}
			_tmp29_ = _data24_->widget;
			_tmp30_ = _tmp29_->widget;
			gtk_widget_show (_tmp30_);
			block24_data_unref (_data24_);
			_data24_ = NULL;
		}
		_g_object_unref0 (_widget_it);
	}
	maya_view_source_dialog_check_can_validate (self);
}


static gchar*
string_chug (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strchug (_tmp1_);
	result = _result_;
	return result;
}


static void
maya_view_source_dialog_entry_changed (MayaViewSourceDialog* self,
                                       MayaPlacementWidget* widget)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	GtkWidget* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = self->priv->widgets_checked;
	_tmp1_ = widget->ref_name;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _tmp1_, NULL);
	_tmp2_ = self->priv->widgets_checked;
	_tmp3_ = widget->ref_name;
	_tmp4_ = widget->widget;
	_tmp5_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_entry_get_type (), GtkEntry));
	_tmp6_ = _tmp5_;
	_tmp7_ = string_chug (_tmp6_);
	_tmp8_ = _tmp7_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, _tmp3_, (gpointer) ((gintptr) (g_utf8_strlen (_tmp8_, (gssize) -1) > 0)));
	_g_free0 (_tmp8_);
	maya_view_source_dialog_check_can_validate (self);
}


static void
maya_view_source_dialog_check_can_validate (MayaViewSourceDialog* self)
{
	GtkEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _valid_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->widgets_checked;
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_valid_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean valid = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			gboolean _tmp9_;
			_tmp6_ = _valid_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _valid_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			valid = (gboolean) ((gintptr) _tmp8_);
			_tmp9_ = valid;
			if (_tmp9_ == FALSE) {
				GtkButton* _tmp10_;
				_tmp10_ = self->priv->create_button;
				gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
				_g_object_unref0 (_valid_it);
				return;
			}
		}
		_g_object_unref0 (_valid_it);
	}
	_tmp11_ = self->priv->name_entry;
	_tmp12_ = gtk_entry_get_text (_tmp11_);
	_tmp13_ = _tmp12_;
	if (g_strcmp0 (_tmp13_, "") != 0) {
		GtkButton* _tmp14_;
		_tmp14_ = self->priv->create_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
	}
}


void
maya_view_source_dialog_save (MayaViewSourceDialog* self)
{
	MayaViewEventType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_event_type;
	if (_tmp0_ == MAYA_VIEW_EVENT_TYPE_ADD) {
		MayaBackend* _tmp1_;
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GtkColorButton* _tmp5_;
		GdkRGBA* _tmp6_;
		GdkRGBA* _tmp7_;
		GdkRGBA _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gboolean _tmp11_;
		GeeCollection* _tmp12_;
		_tmp1_ = self->priv->current_backend;
		_tmp2_ = self->priv->name_entry;
		_tmp3_ = gtk_entry_get_text (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = self->priv->color_button;
		g_object_get (_tmp5_, "rgba", &_tmp6_, NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = *_tmp7_;
		_tmp9_ = maya_util_get_hexa_color (&_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = self->priv->set_as_default;
		_tmp12_ = self->priv->backend_widgets;
		maya_backend_add_new_calendar (_tmp1_, _tmp4_, _tmp10_, _tmp11_, _tmp12_);
		_g_free0 (_tmp10_);
		g_signal_emit (self, maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL], 0);
	} else {
		MayaBackend* _tmp13_;
		GtkEntry* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		GtkColorButton* _tmp17_;
		GdkRGBA* _tmp18_;
		GdkRGBA* _tmp19_;
		GdkRGBA _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gboolean _tmp23_;
		GeeCollection* _tmp24_;
		ESource* _tmp25_;
		_tmp13_ = self->priv->current_backend;
		_tmp14_ = self->priv->name_entry;
		_tmp15_ = gtk_entry_get_text (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = self->priv->color_button;
		g_object_get (_tmp17_, "rgba", &_tmp18_, NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = *_tmp19_;
		_tmp21_ = maya_util_get_hexa_color (&_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = self->priv->set_as_default;
		_tmp24_ = self->priv->backend_widgets;
		_tmp25_ = self->priv->source;
		maya_backend_modify_calendar (_tmp13_, _tmp16_, _tmp22_, _tmp23_, _tmp24_, _tmp25_);
		_g_free0 (_tmp22_);
		g_signal_emit (self, maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL], 0);
	}
}


MayaViewEventType
maya_view_source_dialog_get_event_type (MayaViewSourceDialog* self)
{
	MayaViewEventType result;
	MayaViewEventType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_event_type;
	result = _tmp0_;
	return result;
}


static void
maya_view_source_dialog_set_event_type (MayaViewSourceDialog* self,
                                        MayaViewEventType value)
{
	g_return_if_fail (self != NULL);
	if (maya_view_source_dialog_get_event_type (self) != value) {
		self->priv->_event_type = value;
		g_object_notify_by_pspec ((GObject *) self, maya_view_source_dialog_properties[MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY]);
	}
}


static void
maya_view_source_dialog_class_init (MayaViewSourceDialogClass * klass)
{
	maya_view_source_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MayaViewSourceDialogPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_maya_view_source_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_maya_view_source_dialog_set_property;
	G_OBJECT_CLASS (klass)->finalize = maya_view_source_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY, maya_view_source_dialog_properties[MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY] = g_param_spec_enum ("event-type", "event-type", "event-type", MAYA_VIEW_TYPE_EVENT_TYPE, MAYA_VIEW_EVENT_TYPE_EDIT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL] = g_signal_new ("go-back", MAYA_VIEW_TYPE_SOURCE_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
maya_view_source_dialog_instance_init (MayaViewSourceDialog * self)
{
	self->priv = MAYA_VIEW_SOURCE_DIALOG_GET_PRIVATE (self);
	self->priv->_event_type = MAYA_VIEW_EVENT_TYPE_EDIT;
	self->priv->set_as_default = FALSE;
	self->priv->source = NULL;
}


static void
maya_view_source_dialog_finalize (GObject * obj)
{
	MayaViewSourceDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog);
	_g_object_unref0 (self->priv->name_entry);
	_g_object_unref0 (self->priv->color_button);
	_g_object_unref0 (self->priv->current_backend);
	_g_object_unref0 (self->priv->backend_widgets);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->widgets_checked);
	_g_object_unref0 (self->priv->create_button);
	_g_object_unref0 (self->priv->type_combobox);
	_g_object_unref0 (self->priv->list_store);
	_g_object_unref0 (self->priv->source);
	G_OBJECT_CLASS (maya_view_source_dialog_parent_class)->finalize (obj);
}


GType
maya_view_source_dialog_get_type (void)
{
	static volatile gsize maya_view_source_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&maya_view_source_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MayaViewSourceDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_view_source_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaViewSourceDialog), 0, (GInstanceInitFunc) maya_view_source_dialog_instance_init, NULL };
		GType maya_view_source_dialog_type_id;
		maya_view_source_dialog_type_id = g_type_register_static (gtk_grid_get_type (), "MayaViewSourceDialog", &g_define_type_info, 0);
		g_once_init_leave (&maya_view_source_dialog_type_id__volatile, maya_view_source_dialog_type_id);
	}
	return maya_view_source_dialog_type_id__volatile;
}


static void
_vala_maya_view_source_dialog_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	MayaViewSourceDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog);
	switch (property_id) {
		case MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY:
		g_value_set_enum (value, maya_view_source_dialog_get_event_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_maya_view_source_dialog_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	MayaViewSourceDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog);
	switch (property_id) {
		case MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY:
		maya_view_source_dialog_set_event_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



